package metier;

import java.util.ArrayList;
import java.util.Vector;

/**
 *
 * @author Dominique_2
 */
public class Jeu {

    private String nomJeu;
    private ArrayList<Personnage> lesPersonnages;

    /**
     * @return the nomJeu
     */
    public String getNomJeu() {
        return nomJeu;
    }

    /**
     * @return the lesPersonnages
     */
    public ArrayList<Personnage> getLesPersonnages() {
        return lesPersonnages;
    }

    @Override
    public String toString() {
        return "Jeu{" + "lesPersonnages=" + lesPersonnages + '}';
    }

    /**
     * Constructeur
     *
     * @param nomJeu
     */
    public Jeu(String nomJeu) {
        this.nomJeu = nomJeu;
        this.lesPersonnages = new ArrayList<>();
        chargerLesPersonnages();
    }

    /**
     * Création des personnages du jeu
     */
    public void chargerLesPersonnages() {
        Personnage g1 = new Guerrier("Dudule", "Guerrier05.JPG", 5, 6, "Epée");
        Personnage g2 = new Guerrier("Toto", "Guerrier10.JPG", 8, 7, "Epée");
        Personnage g3 = new Guerrier("Dur à cuire", "Guerrier08.JPG", 4, 5, "Poignard");
        Personnage g4 = new Guerrier("Prêt à tout", "Guerrier12.JPG", 6, 4, "Matraque");
        lesPersonnages.add(g1);
        lesPersonnages.add(g2);
        lesPersonnages.add(g3);
        lesPersonnages.add(g4);

        Personnage clampin = new Personnage("Simone", "Simone.JPG", 4, 3);
        lesPersonnages.add(clampin);

        Sorcier s1 = new Sorcier("Panoramix", "panoramix.gif", 10, 5, "Sortilèges");
        Enigme uneEnigme = new Enigme("Je suis vague en bord de mer.\n"
                + "Je descends des montagnes en hiver.\n"
                + "Sans moi vous n'aurez plus une larme.",
                "L'eau");
        s1.ajouterEnigme(uneEnigme);
        uneEnigme = new Enigme("Je serai hier, j'étais demain.",
                "Aujourd'hui");
        s1.ajouterEnigme(uneEnigme);
        uneEnigme = new Enigme("Si de ton doigt tu veux me toucher, apprête toi alors à le retirer.\n"
                + "Mais si tu sais me manipuler ta demeure en sera réchauffée et illuminée.\n"
                + "Qui suis-je ?",
                "Le feu");
        s1.ajouterEnigme(uneEnigme);
        uneEnigme = new Enigme("Je suis si fragile que lorsque l'on prononce mon nom, je meurs.",
                "Le silence");
        s1.ajouterEnigme(uneEnigme);
        lesPersonnages.add(s1);
        s1 = new Sorcier("FaitPeur", "Sorcier02.JPG", 10, 4, "Sortilèges");
        s1.ajouterEnigme(uneEnigme);
        uneEnigme = new Enigme("Connu pour ses galeries,\n"
                + "Et le ton de son gris,\n"
                + "Elle évoque la mauvaise vision,\n"
                + "Et c'est un excellent espion",
                "La taupe");
        s1.ajouterEnigme(uneEnigme);
        uneEnigme = new Enigme("Symbole de maladresse, pour beaucoup je suis signe de malédiction.\n"
                + "Quand on passe l'arme, c'est parfois à moi.\n"
                + "Que suis-je ?",
                "La gauche");
        s1.ajouterEnigme(uneEnigme);
        uneEnigme = new Enigme("Vous ne pouvez que me deviner et ne pouvez qu'avancer vers moi.\n"
                + "Quand vous arrivez, je ne suis plus là.\n"
                + "Car à chaque pas avancé, je recule d'autant.\n"
                + "Que suis-je ?",
                "Le futur");
        s1.ajouterEnigme(uneEnigme);
        lesPersonnages.add(s1);

        Personnage rapTout = new Voleur("Raptout", "Barbare04.jpg", 2, 4, "Tournevis");
        lesPersonnages.add(rapTout);
    }

    /**
     * Recherche du personnage dont le nom est passé en paramètre
     *
     * @param n nom du personnage recherché
     * @return personnage correspondant au nom s'il existe, null sinon
     */
    public Personnage rechercherPerso(String n) {
        int i = 0;
        Personnage p = null;
        while (p == null && i < lesPersonnages.size()) {
            if (lesPersonnages.get(i).getNom().equals(n)) {
                p = lesPersonnages.get(i);
            } else {
                i++;
            }
        }
        return p;
    }

    /**
     * Recherche d'un nombre aléatoire entre min et max inclus
     *
     * @param min
     * @param max
     * @return entier compris entre min et max
     */
    public static int genererNbAleatoire(int min, int max) {
        return min + (int) (Math.random() * ((max - min) + 1));
    }
    
    /*  public Vector<String> getPersonnagesVivants{
    

}
 */
    
    
}
